## ros-humble-rmf-task 2.1.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

project(rmf_task VERSION 2.1.3)

set(CMAKE_EXPORT_COMPILE_COMMANDS on)

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

if(NOT CMAKE_BUILD_TYPE)
  # Use the Release build type by default if the user has not specified one
  set(CMAKE_BUILD_TYPE Release)
endif()

include(GNUInstallDirs)

find_package(rmf_utils REQUIRED)
find_package(rmf_traffic REQUIRED)
find_package(rmf_battery REQUIRED)
find_package(Eigen3 REQUIRED)
find_package(Threads)

find_package(ament_cmake_catch2 QUIET)
find_package(ament_cmake_uncrustify QUIET)

# ===== RMF Tasks library
file(GLOB_RECURSE lib_srcs
  "src/rmf_task/*.cpp"
)

add_library(rmf_task SHARED
  ${lib_srcs}
)

target_link_libraries(rmf_task
  PUBLIC
    rmf_battery::rmf_battery
    Threads::Threads
    $<$<CXX_COMPILER_ID:GNU>:stdc++fs>
)

target_include_directories(rmf_task
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    ${EIGEN3_INCLUDE_DIRS}
)

if(BUILD_TESTING AND ament_cmake_catch2_FOUND AND ament_cmake_uncrustify_FOUND)
  file(GLOB_RECURSE unit_test_srcs "test/*.cpp")

  ament_add_catch2(
    test_rmf_task test/main.cpp ${unit_test_srcs}
    TIMEOUT 300)
  target_link_libraries(test_rmf_task
      rmf_task
      rmf_utils::rmf_utils
      rmf_traffic::rmf_traffic
  )

  target_include_directories(test_rmf_task
    PRIVATE
      $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/>
  )

  find_file(uncrustify_config_file
    NAMES "rmf_code_style.cfg"
    PATHS "${rmf_utils_DIR}/../../../share/rmf_utils/")

  ament_uncrustify(
    ARGN include src test
    CONFIG_FILE ${uncrustify_config_file}
    MAX_LINE_LENGTH 80
  )
endif()


# Create cmake config files
include(CMakePackageConfigHelpers)

set(INSTALL_CONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/rmf_task/cmake")
set(PACKAGE_CONFIG_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/rmf_task-config-version.cmake")
set(PACKAGE_CONFIG_FILE "${CMAKE_CURRENT_BINARY_DIR}/rmf_task-config.cmake")

configure_package_config_file(
  "${CMAKE_CURRENT_LIST_DIR}/cmake/rmf_task-config.cmake.in"
  ${PACKAGE_CONFIG_FILE}
  INSTALL_DESTINATION ${INSTALL_CONFIG_DIR}
)

write_basic_package_version_file(
  ${PACKAGE_CONFIG_VERSION_FILE}
  COMPATIBILITY ExactVersion
)

install(
  TARGETS rmf_task
  EXPORT  rmf_task-targets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
  DIRECTORY include/rmf_task
  DESTINATION include
)

install(
  FILES
    ${PACKAGE_CONFIG_VERSION_FILE}
    ${PACKAGE_CONFIG_FILE}
  DESTINATION ${INSTALL_CONFIG_DIR}
)

install(
  EXPORT rmf_task-targets
  FILE rmf_task-targets.cmake
  NAMESPACE rmf_task::
  DESTINATION ${INSTALL_CONFIG_DIR}
)

export(
  EXPORT rmf_task-targets
  FILE ${CMAKE_CURRENT_BINARY_DIR}/rmf_task-targets.cmake
  NAMESPACE rmf_task::
)

# Export ament index path
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/ament_index/resource_index/packages/${PROJECT_NAME} "")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/ament_index/resource_index/packages/${PROJECT_NAME} DESTINATION share/ament_index/resource_index/packages)

file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ament_prefix_path.dsv "prepend-non-duplicate;AMENT_PREFIX_PATH;")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ament_prefix_path.dsv DESTINATION share/${PROJECT_NAME}/hook)

=== debian/changelog ===
ros-humble-rmf-task (2.1.6-1jammy) jammy; urgency=high



 -- Yadunund <yadunund@openrobotics.org>  Wed, 09 Aug 2023 16:00:00 -0000

ros-humble-rmf-task (2.1.5-1jammy) jammy; urgency=high

  * Added ``requester`` and ``request_time`` fields to ``rmf_task::Task::Booking`` (#81 <https://github.com/open-rmf/rmf_task/pull/81>)
  * Contributors: Aaron Chong

 -- Yadunund <yadunund@openrobotics.org>  Thu, 29 Jun 2023 16:00:00 -0000

ros-humble-rmf-task (2.1.4-1jammy) jammy; urgency=high

  * Update github actions and fix style as per uncrustify 0.72 (#74 <https://github.com/open-rmf/rmf_task/pull/74>)
  * Contributors: Esteban Martinena, Yadunund

 -- Yadunund <yadunund@openrobotics.org>  Sun, 04 Jun 2023 16:00:00 -0000

ros-humble-rmf-task (2.1.3-1jammy) jammy; urgency=high

  * Fixed unit test for checking automatic insertion of ChargeBattery task (#76 <https://github.com/open-rmf/rmf_task/pull/76>)
  * Add missing buildtool_depend on cmake (#75 <https://github.com/open-rmf/rmf_task/pull/75>)
  * Contributors: Luca Della Vedova, Scott K Logan, Yadunund

 -- Yadunund <yadunund@openrobotics.org>  Sat, 16 Apr 2022 16:00:00 -0000

ros-humble-rmf-task (2.1.2-1jammy) jammy; urgency=high

  * Removed c++fs option for clang
  * Fixing need of  stdc++fs to build RPM package
  * Contributors: Esteban Martinena

 -- Yadunund <yadunund@openrobotics.org>  Sun, 13 Nov 2022 16:00:00 -0000

ros-humble-rmf-task (2.1.1-1jammy) jammy; urgency=high

  * Allow GoToPlace to know about expected future destinations (#61 <https://github.com/open-rmf/rmf_task/pull/61>)
  * Contributors: Grey, Marco A. Gutiérrez

 -- Yadunund <yadunund@openrobotics.org>  Mon, 10 Oct 2022 16:00:00 -0000

ros-humble-rmf-task (2.1.0-1jammy) jammy; urgency=high

  * Fix undefined behavior in log: (#62 <https://github.com/open-rmf/rmf_task/pull/62>)
  * Contributors: Grey

 -- Yadunund <yadunund@openrobotics.org>  Wed, 18 May 2022 16:00:00 -0000

ros-humble-rmf-task (2.0.0-1jammy) jammy; urgency=high

  * Support flexible task definitions (#39 <https://github.com/open-rmf/rmf_task/pull/39>)
    * Abstract interfaces are used to define tasks
    * The task interfaces can be given arbitrary implementations by downstream users
  * Contributors: Grey, Xiyu, Yadunund, Youliang

 -- Yadunund <yadunund@openrobotics.org>  Sun, 13 Feb 2022 16:00:00 -0000

ros-humble-rmf-task (1.0.0-1jammy) jammy; urgency=high

  * Fix id for ParkRobotFactory: (#37 <https://github.com/open-rmf/rmf_task/pull/37>)
  * New TaskPlanner::Options, TaskPlanner::plan(), RequestFactory APIs: (#28 <https://github.com/open-rmf/rmf_task/pull/28>)
  * Remove dependency on rmf_dispenser_msgs: (#36 <https://github.com/open-rmf/rmf_task/pull/36>)
  * Bug fix when battery_soc of robot is greater than recharge_soc: (#30 <https://github.com/open-rmf/rmf_task/pull/30>)
  * Contributors: Yadunund

 -- Yadunund <yadunund@openrobotics.org>  Tue, 31 Aug 2021 16:00:00 -0000

ros-humble-rmf-task (0.1.0-1jammy) jammy; urgency=high

  * Provides ``rmf_task::requests`` to describe various task requests which may be used for allocation planning
  * Provides ``rmf_task::agv::TaskPlanner`` object that can generate task allocation plans where a set of ``rmf_task::requests`` are optimally distributed across a set of agents
  * ``rmf_task::requests::ChargeBattery`` requests are automatically injected into the allocation set where necessary

 -- Yadunund <yadunund@openrobotics.org>  Thu, 03 Jun 2021 16:00:00 -0000

=== debian/control ===
Source: ros-humble-rmf-task
Section: misc
Priority: optional
Maintainer: Yadunund <yadunund@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), cmake, libeigen3-dev, ros-humble-ament-cmake-catch2 <!nocheck>, ros-humble-ament-cmake-uncrustify <!nocheck>, ros-humble-rmf-battery, ros-humble-rmf-utils, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rmf-task
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-humble-rmf-battery, ros-humble-rmf-utils, ros-humble-ros-workspace
Description: Package for managing tasks in the Robotics Middleware Framework

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rmf-task//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-rmf-task//opt/ros/humble/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install

## ros-humble-rmf-task 2.1.8

=== debian/changelog ===
ros-humble-rmf-task (2.1.8-1bookworm) bookworm; urgency=high



 -- Yadunund <yadunund@openrobotics.org>  Thu, 21 Dec 2023 16:00:00 -0000

ros-humble-rmf-task (2.1.7-1bookworm) bookworm; urgency=high

  * Fix race condition risk for task sequences (#102 <https://github.com/open-rmf/rmf_task/pull/102>)
  * Allow charging tasks to run indefinitely (#99 <https://github.com/open-rmf/rmf_task/pull/99>, #100 <https://github.com/open-rmf/rmf_task/pull/100>)

 -- Yadunund <yadunund@openrobotics.org>  Thu, 14 Dec 2023 16:00:00 -0000

ros-humble-rmf-task (2.1.6-1bookworm) bookworm; urgency=high



 -- Yadunund <yadunund@openrobotics.org>  Wed, 09 Aug 2023 16:00:00 -0000

ros-humble-rmf-task (2.1.5-1bookworm) bookworm; urgency=high

  * Added ``requester`` and ``request_time`` fields to ``rmf_task::Task::Booking`` (#81 <https://github.com/open-rmf/rmf_task/pull/81>)
  * Contributors: Aaron Chong

 -- Yadunund <yadunund@openrobotics.org>  Thu, 29 Jun 2023 16:00:00 -0000

ros-humble-rmf-task (2.1.4-1bookworm) bookworm; urgency=high

  * Update github actions and fix style as per uncrustify 0.72 (#74 <https://github.com/open-rmf/rmf_task/pull/74>)
  * Contributors: Esteban Martinena, Yadunund

 -- Yadunund <yadunund@openrobotics.org>  Sun, 04 Jun 2023 16:00:00 -0000

ros-humble-rmf-task (2.1.3-1bookworm) bookworm; urgency=high

  * Fixed unit test for checking automatic insertion of ChargeBattery task (#76 <https://github.com/open-rmf/rmf_task/pull/76>)
  * Add missing buildtool_depend on cmake (#75 <https://github.com/open-rmf/rmf_task/pull/75>)
  * Contributors: Luca Della Vedova, Scott K Logan, Yadunund

 -- Yadunund <yadunund@openrobotics.org>  Sat, 16 Apr 2022 16:00:00 -0000

ros-humble-rmf-task (2.1.2-1bookworm) bookworm; urgency=high

  * Removed c++fs option for clang
  * Fixing need of  stdc++fs to build RPM package
  * Contributors: Esteban Martinena

 -- Yadunund <yadunund@openrobotics.org>  Sun, 13 Nov 2022 16:00:00 -0000

ros-humble-rmf-task (2.1.1-1bookworm) bookworm; urgency=high

  * Allow GoToPlace to know about expected future destinations (#61 <https://github.com/open-rmf/rmf_task/pull/61>)
  * Contributors: Grey, Marco A. Gutiérrez

 -- Yadunund <yadunund@openrobotics.org>  Mon, 10 Oct 2022 16:00:00 -0000

ros-humble-rmf-task (2.1.0-1bookworm) bookworm; urgency=high

  * Fix undefined behavior in log: (#62 <https://github.com/open-rmf/rmf_task/pull/62>)
  * Contributors: Grey

 -- Yadunund <yadunund@openrobotics.org>  Wed, 18 May 2022 16:00:00 -0000

ros-humble-rmf-task (2.0.0-1bookworm) bookworm; urgency=high

  * Support flexible task definitions (#39 <https://github.com/open-rmf/rmf_task/pull/39>)
    * Abstract interfaces are used to define tasks
    * The task interfaces can be given arbitrary implementations by downstream users
  * Contributors: Grey, Xiyu, Yadunund, Youliang

 -- Yadunund <yadunund@openrobotics.org>  Sun, 13 Feb 2022 16:00:00 -0000

ros-humble-rmf-task (1.0.0-1bookworm) bookworm; urgency=high

  * Fix id for ParkRobotFactory: (#37 <https://github.com/open-rmf/rmf_task/pull/37>)
  * New TaskPlanner::Options, TaskPlanner::plan(), RequestFactory APIs: (#28 <https://github.com/open-rmf/rmf_task/pull/28>)
  * Remove dependency on rmf_dispenser_msgs: (#36 <https://github.com/open-rmf/rmf_task/pull/36>)
  * Bug fix when battery_soc of robot is greater than recharge_soc: (#30 <https://github.com/open-rmf/rmf_task/pull/30>)
  * Contributors: Yadunund

 -- Yadunund <yadunund@openrobotics.org>  Tue, 31 Aug 2021 16:00:00 -0000

ros-humble-rmf-task (0.1.0-1bookworm) bookworm; urgency=high

  * Provides ``rmf_task::requests`` to describe various task requests which may be used for allocation planning
  * Provides ``rmf_task::agv::TaskPlanner`` object that can generate task allocation plans where a set of ``rmf_task::requests`` are optimally distributed across a set of agents
  * ``rmf_task::requests::ChargeBattery`` requests are automatically injected into the allocation set where necessary

 -- Yadunund <yadunund@openrobotics.org>  Thu, 03 Jun 2021 16:00:00 -0000
